#include    <stdio.h>
#ifdef _DCC
#include    <exec/types.h>
#include    <exec/io.h>
#include    <exec/devices.h>
#endif
#ifdef QDOS
char _prog_name[] = "picoEmacs";
#endif

#include    "ed.h"

extern  int     ttopen();               /* Forward references.          */
extern  int     ttgetc();
extern  int     ttputc();
extern  int     ttflush();
extern  int     ttclose();
extern  int     ttmove();
extern  int     tteeol();
extern  int     tteeop();
extern  int     ttbeep();

/*
 * Standard terminal interface dispatch table.  Most terminal functions
 * in this module, some in "termio".
 */
TERM term    = {
        22,
        80,
        ttopen,
        ttclose,
        ttgetc,
        ttputc,
        ttflush,
        ttmove,
        tteeol,
        tteeop,
        ttbeep
};

#ifdef _DCC
static void CookIt (void)
{
    SetMode (fdtofh (fileno (stdin)), 0);
}
#endif
ttopen()
{
    setvbuf (stdin, NULL, _IONBF, 0);
    setvbuf (stdout, NULL, _IONBF, 0);
#ifdef _DCC
    atexit (CookIt);
    SetMode (fdtofh (fileno (stdin)), 1);
#endif
}
ttclose()
{
    tteeop();
}       

ttgetc()
{
    int c;
    if((c = getchar()) == EOF)
    {
        exit(0);
    }
    else
    {
        return c;
    }
}

ttputc(int c)
{
    putchar(c);
}

ttflush()
{
}

ttmove(row, col)
int row, col;
{
   printf("\033[%d;%dH", row+1, col+1);
}

tteeol()
{
   fputs("\033[0K", stdout);
}

tteeop()
{
    fputs("\033[0K\033[0J", stdout);
}

ttbeep()
{
   putchar('\a');
}
